VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "BEShutdown Sample Application"
   ClientHeight    =   3408
   ClientLeft      =   48
   ClientTop       =   432
   ClientWidth     =   4356
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3408
   ScaleWidth      =   4356
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdApply 
      Caption         =   "&Apply"
      Height          =   372
      Left            =   1704
      TabIndex        =   5
      Top             =   2952
      Width           =   948
   End
   Begin VB.Frame Frame1 
      Caption         =   " Select an option "
      Height          =   2748
      Left            =   72
      TabIndex        =   0
      Top             =   108
      Width           =   4188
      Begin VB.OptionButton Option1 
         Caption         =   "Shutdown"
         Height          =   408
         Index           =   1
         Left            =   468
         TabIndex        =   6
         Top             =   864
         Width           =   1560
      End
      Begin VB.OptionButton Option1 
         Caption         =   "Exit Application"
         Height          =   408
         Index           =   4
         Left            =   470
         TabIndex        =   4
         Top             =   2196
         Width           =   1560
      End
      Begin VB.OptionButton Option1 
         Caption         =   "Power Off"
         Height          =   408
         Index           =   3
         Left            =   470
         TabIndex        =   3
         Top             =   1764
         Width           =   1560
      End
      Begin VB.OptionButton Option1 
         Caption         =   "Reboot"
         Height          =   408
         Index           =   2
         Left            =   470
         TabIndex        =   2
         Top             =   1332
         Width           =   1560
      End
      Begin VB.OptionButton Option1 
         Caption         =   "Logoff"
         Height          =   408
         Index           =   0
         Left            =   470
         TabIndex        =   1
         Top             =   432
         Width           =   1560
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Enum EnumExitWindows
  WE_LOGOFF = 0
  WE_SHUTDOWN = 1
  WE_REBOOT = 2
  WE_POWEROFF = 8
End Enum

Const SW_SHOWNORM = 1
Const SW_SHOWMIN = 2
Const SW_SHOWMAX = 3

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, _
   ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, _
   ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Private m_strVBShutdownPathAndFileName As String
Private m_iCurrentSelection As Integer

Private Sub cmdApply_Click()
Call ProcessExitCommand
End Sub

Private Sub Form_Load()
Dim i As Integer

m_iCurrentSelection = 99 'set a bogus default in case the apply button is clicked by accident

'set the option defaults so nothing is selected
For i = 0 To 4
    Option1(i).Value = False
Next i

'set the path and file name of BEShutdown.exe
m_strVBShutdownPathAndFileName = App.Path & "\BEShutdown.exe"

End Sub
'******************************************
'* This function processes the exit command when the APPLY command button is clicked
'* Input:      None
'* Output:     None
'* Programmer: MBevan
'* Date:       30/Oct/2005
'******************************************
Private Sub ProcessExitCommand()
Dim n_strMessage As String
Dim n_lHandle As Long

On Error GoTo EH_ProcessExitCommand

Select Case m_iCurrentSelection
    Case 0: 'logoff
        If ValidateExit() Then
            n_lHandle = ShellExecute(0, "Open", m_strVBShutdownPathAndFileName, WE_LOGOFF, 0, SW_SHOWNORM)
            End
        End If
    Case 1: 'shutdown (may prompt user to power off)
        If ValidateExit() Then
            n_lHandle = ShellExecute(0, "Open", m_strVBShutdownPathAndFileName, WE_SHUTDOWN, 0, SW_SHOWNORM)
            End
        End If
    Case 2: 'reboot
        If ValidateExit() Then
            n_lHandle = ShellExecute(0, "Open", m_strVBShutdownPathAndFileName, WE_REBOOT, 0, SW_SHOWNORM)
            End
        End If
    Case 3: 'power off
        If ValidateExit() Then
            n_lHandle = ShellExecute(0, "Open", m_strVBShutdownPathAndFileName, WE_POWEROFF, 0, SW_SHOWNORM)
            End
        End If
    Case 4: 'exit the application
        Unload Me
    Case Else
        Call MsgBox("Invalid selection", vbOKOnly + vbExclamation, "System Message")
End Select

NormalExit_ProcessExitCommand:
    On Error GoTo 0
    Exit Sub

EH_ProcessExitCommand:
    n_strMessage = "ProcessExit function failed with error: " & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_ProcessExitCommand

Resume_ProcessExitCommand:
    Err.Clear
    Resume Next

End Sub
'******************************************
'* This function ensures the user really wants to proceed. Work could be lost, so be careful!
'* Input:      None
'* Output:     if true, the user really does want to proceed with shutdown/logoff
'* Programmer: MBevan
'* Date:       30/Oct/2005
'******************************************
Public Function ValidateExit() As Boolean
Dim n_bReturnValue As Boolean
Dim n_iReturnValue As Integer
Dim n_strPromptMessage As String, n_strMessage As String

On Error GoTo EH_ValidateExit
n_bReturnValue = False

n_strPromptMessage = "Are you sure you want to shutdown/logoff? Unsaved data could be lost"
n_iReturnValue = MsgBox(n_strPromptMessage, vbYesNo + vbQuestion, "System Message")
If n_iReturnValue = vbYes Then n_bReturnValue = True

NormalExit_ValidateExit:
    ValidateExit = n_bReturnValue
    On Error GoTo 0
    Exit Function

EH_ValidateExit:
    n_strMessage = "ValidateExit function failed with error: " & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_ValidateExit

Resume_ValidateExit:
    Err.Clear
    Resume Next

End Function

Private Sub Option1_Click(Index As Integer)
m_iCurrentSelection = Index
End Sub
